package com.steerinfo.dil.controller;

import com.steerinfo.dil.feign.ColumnDataFeign;
import com.steerinfo.dil.feign.ESFeign;
import com.steerinfo.dil.mapper.AmsContractTruckPriceMapper;
import com.steerinfo.dil.model.AmsContractTransportPrice;
import com.steerinfo.dil.service.IAmsContractTruckPriceService;
import com.steerinfo.dil.util.BaseRESTfulController;
import com.steerinfo.dil.util.ColumnDataUtil;
import com.steerinfo.dil.util.PageListAdd;
import com.steerinfo.framework.controller.RESTfulResult;
import com.steerinfo.framework.service.pagehelper.PageHelper;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiModelProperty;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.math.BigDecimal;
import java.text.ParseException;
import java.util.*;

/**
 * AmsContractTransportPrice RESTful接口：
 * @author generator
 * @version 1.0-SNAPSHORT 2021-09-06 07:10
 * 类描述
 * 修订历史：
 * 日期：2021-09-06
 * 作者：generator
 * 参考：
 * 描述：AmsContractTransportPrice RESTful接口
 * @see null
 * @Copyright 湖南视拓信息技术股份有限公司. All rights reserved.
 */
@RestController
@RequestMapping("/${api.version}/amscontracttruckprices")
public class AmsContractTruckPriceController extends BaseRESTfulController {

    @Autowired
    IAmsContractTruckPriceService amsContractTruckPriceService;


    @Autowired
    ColumnDataFeign columnDataFeign;

    @Autowired
    ColumnDataUtil columnDataUtil;

    @Autowired
    ESFeign esFeign;

    @Autowired
    AmsContractTruckPriceMapper amsContractTruckPriceMapper;

    @ApiOperation(value="查询汽运单价信息")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "apiId(109)", value = "表头", required = false, dataType = "Interger")
    })
    @PostMapping("/getAmsContractTransportPrice1")
    public RESTfulResult getAmsContractTransportPrice(@RequestBody(required=false) Map<String,Object> mapValue,
                                                      Integer apiId,
                                                      Integer pageNum,
                                                      Integer pageSize,
                                                      String con,
                                                      Integer deleted){
        if(deleted != null) {
            mapValue.put("deleted", deleted);
        }
        if(con !=null){
            mapValue.put("con",con);
        }
        PageHelper.startPage(pageNum,pageSize);
        List<Map<String, Object>> amsContractTransportPrice1 = amsContractTruckPriceService.getAmsContractTransportPrice(mapValue);
        PageListAdd pageList = columnDataUtil.tableColumnData(apiId, null,amsContractTransportPrice1);
        return success(pageList);
    }

    @ApiOperation(value="查询内转汽运单价信息")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "apiId(109)", value = "表头", required = false, dataType = "Interger")
    })
    @PostMapping("/getInwardContractPrice")
    public RESTfulResult getInwardContractPrice(@RequestBody(required=false) Map<String,Object> mapValue,
                                                      Integer apiId,
                                                      Integer pageNum,
                                                      Integer pageSize,
                                                      Integer deleted,
                                                      String con){
        if(deleted != null) {
            mapValue.put("deleted", deleted);
        }
        if (con != null && !con.equals("undefined")) {
            mapValue.put("con","%" + con + "%");
        }
        PageHelper.startPage(pageNum,pageSize);
        if ("materialNames".equals(mapValue.get("orderField"))){
            mapValue.put("orderField",null);
        }
        List<Map<String, Object>> amsContractTransportPrice1 = amsContractTruckPriceService.getInwardContractPrice(mapValue);
        if (mapValue.get("materialNames")!=null && !"".equals(mapValue.get("materialNames"))) {
            String materialNames = mapValue.get("materialNames").toString();
            List<Map<String, Object>> amsContractTransportPrice2=new ArrayList<>();
            amsContractTransportPrice1.forEach(map->{
                if (map.get("materialNames")!=null && !"".equals(map.get("materialNames"))) {
                    if (materialNames.equals("["+map.get("materialNames")+"]")) {
                        amsContractTransportPrice2.add(map);
                    }
                }
            });
            amsContractTransportPrice1=amsContractTransportPrice2;
        }
        PageListAdd pageList = columnDataUtil.tableColumnData(apiId, null,amsContractTransportPrice1);
        return success(pageList);
    }

    /**
     * 新增汽运单价
     * @param mapValue
     * @return
     */
    @ApiOperation(value="新增汽运单价")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "amsContractTransportPrice", value = "销售订单对象", required = false, dataType = "AmsContractTransportPrice")
    })
    @PostMapping(value = "/addAmsContractTransportPrice1")
    public RESTfulResult addAmsContractTransportPrice(@RequestBody(required = false) Map<String,Object> mapValue){
        int i = amsContractTruckPriceService.addAmsContractTransportPrice(mapValue);
        return success(i);
    }

    /**
     * 新增内转汽运单价
     * @param mapValue
     * @return
     */
    @ApiOperation(value="新增内转汽运单价")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "amsContractTransportPrice", value = "销售订单对象", required = false, dataType = "AmsContractTransportPrice")
    })
    @PostMapping(value = "/insertInwardPrice")
    public RESTfulResult insertInwardPrice(@RequestBody(required = false) Map<String,Object> mapValue){
        int i = amsContractTruckPriceService.insertInwardPrice(mapValue);
        return success(i);
    }

    /**
     * 通过主键删除汽运单价
     * @param priceId
     * @return
     */
    @ApiOperation(value="通过主键删除汽运单价")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "priceId", value = "主键Id", required = false, dataType = "java.math.BigDecimal")
    })
    @PostMapping(value = "/deleteAmsContractTransportPrice1")
    public RESTfulResult deleteAmsContractTransportPrice(BigDecimal priceId){
        int i = amsContractTruckPriceService.deleteAmsContractTransportPrice(priceId);
        return success(i);
    }

    /**
     * 通过主键渲染汽运单价信息
     * @param priceId
     * @return
     */
    @ApiOperation(value="通过主键渲染汽运单价信息")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "priceId", value = "主键Id", required = false, dataType = "java.math.BigDecimal")
    })
    @PostMapping(value = "/getAmsContractTransportPriceByPriceId1")
    public RESTfulResult getAmsContractTransportPriceByPriceId(@RequestParam BigDecimal priceId){
        List<Map<String, Object>> maps = amsContractTruckPriceService.selectByPriceId(priceId);
        return success(maps);
    }

    /**
     * 通过主键修改汽运单价
     * @param amsContractTransportPrice
     * @return
     */
    @ApiOperation(value="通过主键修改汽运单价")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "amsContractTransportPrice", value = "销售订单对象", required = false, dataType = "AmsContractTransportPrice")
    })
    @PostMapping(value = "/updateAmsContractTransportPrice1")
    public RESTfulResult updateAmsContractTransportPrice(@RequestParam AmsContractTransportPrice amsContractTransportPrice){
        int i = amsContractTruckPriceService.updateAmsContractTransportPrice(amsContractTransportPrice);
        return success(i);
    }

    /**
     * 油价联动导致运价变动，批量修改运价
     * @param
     * @return
     */
    @ApiOperation(value="油价联动导致运价变动，批量修改运价")
    @ApiImplicitParams({
    })
    @PostMapping(value = "/batchUpdateTransportPriceByOilPrice1")
    public RESTfulResult batchUpdateTransportPriceByOilPrice(@RequestBody Map<String,Object> map) throws ParseException {
        int i = amsContractTruckPriceService.batchUpdateTransportPriceByOilPrice(map);
        return success(i);
    }

    /**
     * 获取承运商名称
     * @param
     * @return
     */
    @ApiOperation(value="获取承运商名称")
    @ApiImplicitParams({
    })
    @GetMapping(value = "/getCarrierName")
    public RESTfulResult getCarrierName(){
        return success(amsContractTruckPriceService.getCarrierName());
    }

    /**
     * 获取线路编号
     * @param
     * @return
     */
    @ApiOperation(value="获取线路编号")
    @ApiImplicitParams({
    })
    @GetMapping(value = "/getLineNo")
    public RESTfulResult getLineNo(){
        return success(amsContractTruckPriceService.getLineNo());
    }

    /**
     * 获取运力编号
     * @param
     * @return
     */
    @ApiOperation(value="获取运力编号")
    @ApiImplicitParams({
    })
    @GetMapping(value = "/getCapacityNumber")
    public RESTfulResult getCapacityNumber(){
        return success(amsContractTruckPriceService.getCapacityNumber());
    }

    /**
     * 获取收货地址
     * @param
     * @return
     */
    @ApiOperation(value="获取收货地址")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "apiId" ,value = "255")
    })
    @PostMapping (value = "/getAddressDeliveryAddress")
    public RESTfulResult getAddressDeliveryAddress(@RequestBody(required=false) Map<String,Object> mapValue,
                                                   Integer apiId,
                                                   Integer pageNum,
                                                   Integer pageSize,
                                                   String con){
        if (con != null && !con.equals("undefined")) {
            mapValue.put("con","%" + con + "%");
        }
        //不分页筛选数据
        PageHelper.startPage(pageNum,pageSize);
        //分页数据
        List<Map<String, Object>> saleOrderList = amsContractTruckPriceService.getAddressDeliveryAddress(mapValue);
        List<Map<String, Object>> columnDataList = columnDataFeign.getColumnData(apiId);
        int i=0;
        for (Map<String, Object> columnData : columnDataList) {
            //每个表头字段的过滤条件
            columnData.put("filters", setListMap(saleOrderList, columnData.get("prop").toString()));
            if (i==0){
                columnData.put("min-width","78px");
            }else if (i==2){
                columnData.put("min-width","94px");
            }
            i++;
        }
        PageListAdd pageList = new PageListAdd(saleOrderList);
        pageList.setColumnData(columnDataList);
        //PageListAdd pageList = columnDataUtil.tableColumnData(apiId, null,saleOrderList);
        return success(pageList);
    }

    private Set<Map<String, Object>> setListMap(List<Map<String, Object>> list, String name) {
        Set<Map<String, Object>> setString = new HashSet<>();
        for (Map<String, Object> map : list) {//遍历每条数据
            Map<String, Object> map1 = new HashMap<>();
            //map.get(name)获取每条数据中对应表头字段的数据
            map1.put("text", map.get(name));
            if (map.get(name) != null) {
                map1.put("value", map.get(name));
                setString.add(map1);
            }
        }
        return setString;
    }

    /**
     * 获取货物类型
     * @param
     * @return
     */
    @ApiOperation(value="获取货物类型")
    @ApiImplicitParams({
    })
    @GetMapping(value = "/getCargoName")
    public RESTfulResult getCargoName(){
        return success(amsContractTruckPriceService.getCargoName());
    }

    /**
     * 获取油品名称
     * @param
     * @return
     */
    @ApiOperation(value="获取油品名称")
    @ApiImplicitParams({
    })
    @GetMapping(value = "/getOilTypeName")
    public RESTfulResult getOilTypeName(){
        return success(amsContractTruckPriceService.getOilTypeName());
    }

    @ApiModelProperty(value = "边输边查具体地址")
    @PostMapping("/getRealAddressByLike")
    public RESTfulResult getRealAddressByLike(@RequestParam Integer addressId,@RequestParam String index){
        if (index != null ) {
            if (index.length() == 0 || index.equals("undefined")) {
                index = null;
            }
            else {
                index = "%" + index + "%";
            }
        }
        Map<String,Object> map = new HashMap<>();
        map.put("addressId",addressId);
        map.put("index",index);
        List<Map<String,Object>> mapList = amsContractTruckPriceService.getRealAddressByLike(map);
        return success(mapList);
    }

    @ApiOperation("通过物资，车型，承运起止范围匹配运输单价")
    @PostMapping("/getInwardPriceBy")
    public Map<String,Object> getInwardPriceBy(@RequestBody(required = false) Map<String,Object> mapvalue){
        //接受结算是内转计重还是计时还是计数
        String settleMentType = (String) mapvalue.get("requirementType");
        String insertUpdateRemark = (String) mapvalue.get("insertUpdateRemark");
        BigDecimal type = null;
        if("计重".equals(settleMentType)){
            if(insertUpdateRemark!=null && !"".equals(insertUpdateRemark) && insertUpdateRemark.contains("计时且过计量")){
                //计重且计时，走计时流程
                type = new BigDecimal(5);
            }else{
                //在单价表里内转计重是2
                type = new BigDecimal(2);
            }
        }else if("计时".equals(settleMentType)){
            //在单价表里内转计时是5
            type = new BigDecimal(5);
        }else if("计次".equals(settleMentType)){
            //在单价表里内转计时是6
            type = new BigDecimal(6);
        }
        List<Map<String,Object>> mapList=new LinkedList<>();
        try{
            mapvalue.put("type",type);
             mapList=mapList = amsContractTruckPriceService.selectInwardPrice(mapvalue);
        }catch (Exception e){
            System.out.println("e"+e.getMessage());
        }
        if(mapList.size()!=0){
            return mapList.get(0);
        }
        else{
            return null;
        }
    }

    @ApiOperation(value = "承运起止范围与装货点")
    @PostMapping("/getRangePoint")
    public RESTfulResult getRangePoint(@RequestBody(required = false)Map<String,Object>mapValue,
                                       Integer apiId,
                                       Integer pageNum,
                                       Integer pageSize,
                                       String con){
        if (con != null && !con.equals("undefined")) {
            mapValue.put("con","%" + con + "%");
        }
        //不分页筛选数据
        PageHelper.startPage(pageNum,pageSize);
        //分页数据
        List<Map<String, Object>> rangePointList = amsContractTruckPriceService.getRangePoint(mapValue);
        PageListAdd pageList = columnDataUtil.tableColumnData(apiId, null,rangePointList);
        return success(pageList);
    }

    @ApiOperation(value = "插入承运起止范围与装货点")
    @PostMapping("/insertLineNodePoint")
    public RESTfulResult insertLineNodePoint(@RequestBody(required = false)Map<String,Object>map){
        return success(amsContractTruckPriceService.insertLineNodePoint(map));
    }

    @ApiOperation("根据汽运ID修改单价")
    @PostMapping("updatePriceById")
    public RESTfulResult updatePriceById(@RequestBody(required = false) Map<String,Object> map) {
        //
        int i = amsContractTruckPriceService.updatePriceById(map);
        return success(i);
    }

    @ApiOperation(value = "查询出收货地址ID")
    @PostMapping("/queryPlaceId")
    public BigDecimal queryPlaceId(@RequestBody(required = false) BigDecimal bigDecimal){
        List<Map<String, Object>> maps = amsContractTruckPriceMapper.selectByPriceId(bigDecimal);
        BigDecimal b=BigDecimal.ZERO;
        for (Map<String, Object> map : maps) {
            b = (BigDecimal) map.get("PLACE_ID");
        }
        return b;

    }

    @ApiOperation(value="修改内转汽运单价")
    @PostMapping("/updateTransPrice")
    public RESTfulResult updateTransPrice(@RequestBody(required=false) Map<String,Object> map){
        int i = amsContractTruckPriceService.updatePriceByPriceId(map);
        return success(i);
    }

    @ApiOperation(value="查询物资")
    @PostMapping("/getwz")
    public RESTfulResult getwz(@RequestBody(required=false) Map<String,Object> map){
        List<Map<String, Object>> i = amsContractTruckPriceService.getwz(map);
        return success(i);
    }

    @ApiOperation(value="查询联动公式数据")
    @PostMapping("/getcargonameId")
    public RESTfulResult getcargonameId(@RequestBody(required=false) Map<String,Object> map){
        Map<String, Object> i = amsContractTruckPriceService.getcargonameId(map);
        return success(i);
    }
}
