package com.steerinfo.dil.mapper;

import com.steerinfo.dil.model.DilNotice;
import com.steerinfo.framework.mapper.IBaseMapper;
import java.math.*;
import java.util.List;
import java.util.Map;

import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Select;

@Mapper
public interface DilNoticeMapper extends IBaseMapper<DilNotice, BigDecimal> {

    List<Map<String, Object>> getNoticeList(Map<String, Object> mapVal);

    //承运商查看公告
    List<Map<String, Object>> getCarrierNoticeList(Map<String, Object> mapVal);

    //id自增
    @Select("select seq_DIL_NOTICE.nextval from dual")
    BigDecimal selectNoticeId();

    List<Map<String, Object>> getNoticeById(BigDecimal id);

    List<Map<String, Object>> getNoticeById1(BigDecimal id);
    //销售公司查看公告
    List<Map<String, Object>> getMarketingNoticeList(Map<String, Object> mapVal);
    //收货客户查看公告
    List<Map<String, Object>> getClientNoticeList(Map<String, Object> mapVal);
    //根据不同的用户发放不同的最新消息
    List<Map<String, Object>> getNewNoticeByPermission(BigDecimal permission);

    /**
     * @author:zyf
     * @version:1.0
     * @Date:2022-10-14
     * @Description:
    */
    String getStatus(BigDecimal id);
    /**
     * @author:zyf
     * @version:1.0
     * @Date:
     * @Description: 根据不同的用户发放通知
    */
    List<Map<String, Object>> getNoticeData(String userId);
    /**
     * @author:zyf
     * @version:1.0
     * @Date:
     * @Description: 根据不同的用户发放通知1
     */
    List<Map<String, Object>> getNoticeData1();

    /**
     * @author:zyf
     * @version:1.0
     * @Date:2022-09-23
     * @Description:新增通知(承运商,销售客户，收货客户)
    */
    int insertIntoNoticeUser(DilNotice dilNotice);

    /**
     * @author:zyf
     * @version:1.0
     * @Date:2022-09-23
     * @Description:新增通知（所有人）
    */
    int insertIntoNoticeUser1(DilNotice dilNotice);

    /**
     * @author:zyf
     * @version:1.0
     * @Date:2022-09-23
     * @Description:更新通知的相关信息
    */
    int updateNotice(DilNotice dilNotice);

    /**
     * @author:zyf
     * @version:1.0
     * @Date:2022-09-23
     * @Description:删除与该通知有关用户中间表的信息
    */
    int deleteNoticeUsers(BigDecimal id);

    /**
     * @author:zyf
     * @version:1.0
     * @Date:2022-09-23
     * @Description:删除与该通知表的信息
     */
    int deleteNotice(BigDecimal id);

    /**
     * @author:zyf
     * @version:1.0
     * @Date:2022-09-24
     * @Description:根据通知ID来查询orgcode
    */
    String getorgCode(BigDecimal noticeid);

    /**
     * @author:zyf
     * @version:1.0
     * @Date:2022-09-26
     * @Description:根据通知ID来查询历史orgcode
     */
    DilNotice gethistoryorgCode(BigDecimal noticeid);

    /**
     * @author:zyf
     * @version:1.0
     * @Date:2022-09-24
     * @Description:根据用户id来更新状态
    */
    int updatestatus(String userId,int noticeId);

    /**
     * @author:zyf
     * @version:1.0
     * @Date:2022-10-14
     * @Description:
    */
    int gettaskAllNum(String userId);

    /**
     * @author:zyf
     * @version:1.0
     * @Date:2022-09-26
     * @Description:根据用户ID来查询名字
    */
    String queryName(String userId);

    /**
     * @author:zyf
     * @version:1.0
     * @Date:2022-10-14
     * @Description:删除历史数据
    */
    int updatehistorydata(DilNotice dilNotice);

    /**
     * @author:zyf
     * @version:1.0
     * @Date:2022-10-14
     * @Description:更新一下时间
    */
    int updateTime(DilNotice dilNotice);

    /**
     * @author:zyf
     * @version:1.0
     * @Date:2022-10-14
     * @Description:修改数据
    */
    int modifyData(DilNotice dilNotice);
}