package com.steerinfo.dil.model;

import com.steerinfo.framework.model.IBasePO;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;

import java.math.BigDecimal;
import java.util.Date;

@ApiModel(value="抽查信息")
public class RmsCheckInfo implements IBasePO<BigDecimal> {
    /**
     * 主键ID(CHECK_ID,DECIMAL,38)
     */
    @ApiModelProperty(value="主键ID",required=true)
    private BigDecimal checkId;

    /**
     * 抽查炉号(CHECK_LUNO,VARCHAR,20)
     */
    @ApiModelProperty(value="抽查炉号",required=false)
    private String checkLuno;

    /**
     * 抽查支数(CHECK_COUNT,DECIMAL,38)
     */
    @ApiModelProperty(value="抽查支数",required=false)
    private BigDecimal checkCount;

    /**
     * 抽查重量(CHECK_WEIGHT,DECIMAL,38)
     */
    @ApiModelProperty(value="抽查重量",required=false)
    private BigDecimal checkWeight;

    /**
     * 单支重量平均值(CHECK_SINGLE_WEIGHT,DECIMAL,38)
     */
    @ApiModelProperty(value="单支重量平均值",required=false)
    private BigDecimal checkSingleWeight;

    /**
     * 记录创建人(INSERT_USERNAME,VARCHAR,20)
     */
    @ApiModelProperty(value="记录创建人",required=false)
    private String insertUsername;

    /**
     * 记录创建时间(INSERT_TIME,TIMESTAMP,7)
     */
    @ApiModelProperty(value="记录创建时间",required=false)
    private Date insertTime;

    /**
     * 记录修改人(UPDATE_USERNAME,VARCHAR,20)
     */
    @ApiModelProperty(value="记录修改人",required=false)
    private String updateUsername;

    /**
     * 记录修改时间(UPDATE_TIME,TIMESTAMP,7)
     */
    @ApiModelProperty(value="记录修改时间",required=false)
    private Date updateTime;

    /**
     * 记录创建或修改备注(INSERT_UPDATE_REMARK,VARCHAR,100)
     */
    @ApiModelProperty(value="记录创建或修改备注",required=false)
    private String insertUpdateRemark;

    /**
     * 逻辑删除（0：未删除；1：已删除）(DELETED,DECIMAL,0)
     */
    @ApiModelProperty(value="逻辑删除（0：未删除；1：已删除）",required=false)
    private Short deleted;

    private static final long serialVersionUID = 1L;

    @Override
    public BigDecimal getId() {
        return this.checkId;
    }

    @Override
    public void setId(BigDecimal checkId) {
        this.checkId = checkId;
    }

    public BigDecimal getCheckId() {
        return checkId;
    }

    public void setCheckId(BigDecimal checkId) {
        this.checkId = checkId;
    }

    public String getCheckLuno() {
        return checkLuno;
    }

    public void setCheckLuno(String checkLuno) {
        this.checkLuno = checkLuno == null ? null : checkLuno.trim();
    }

    public BigDecimal getCheckCount() {
        return checkCount;
    }

    public void setCheckCount(BigDecimal checkCount) {
        this.checkCount = checkCount;
    }

    public BigDecimal getCheckWeight() {
        return checkWeight;
    }

    public void setCheckWeight(BigDecimal checkWeight) {
        this.checkWeight = checkWeight;
    }

    public BigDecimal getCheckSingleWeight() {
        return checkSingleWeight;
    }

    public void setCheckSingleWeight(BigDecimal checkSingleWeight) {
        this.checkSingleWeight = checkSingleWeight;
    }

    public String getInsertUsername() {
        return insertUsername;
    }

    public void setInsertUsername(String insertUsername) {
        this.insertUsername = insertUsername == null ? null : insertUsername.trim();
    }

    public Date getInsertTime() {
        return insertTime;
    }

    public void setInsertTime(Date insertTime) {
        this.insertTime = insertTime;
    }

    public String getUpdateUsername() {
        return updateUsername;
    }

    public void setUpdateUsername(String updateUsername) {
        this.updateUsername = updateUsername == null ? null : updateUsername.trim();
    }

    public Date getUpdateTime() {
        return updateTime;
    }

    public void setUpdateTime(Date updateTime) {
        this.updateTime = updateTime;
    }

    public String getInsertUpdateRemark() {
        return insertUpdateRemark;
    }

    public void setInsertUpdateRemark(String insertUpdateRemark) {
        this.insertUpdateRemark = insertUpdateRemark == null ? null : insertUpdateRemark.trim();
    }

    public Short getDeleted() {
        return deleted;
    }

    public void setDeleted(Short deleted) {
        this.deleted = deleted;
    }

    @Override
    public String toString() {
        StringBuilder sb = new StringBuilder();
        sb.append(getClass().getSimpleName());
        sb.append(" [");
        sb.append("Hash = ").append(hashCode());
        sb.append(", checkId=").append(checkId);
        sb.append(", checkLuno=").append(checkLuno);
        sb.append(", checkCount=").append(checkCount);
        sb.append(", checkWeight=").append(checkWeight);
        sb.append(", checkSingleWeight=").append(checkSingleWeight);
        sb.append(", insertUsername=").append(insertUsername);
        sb.append(", insertTime=").append(insertTime);
        sb.append(", updateUsername=").append(updateUsername);
        sb.append(", updateTime=").append(updateTime);
        sb.append(", insertUpdateRemark=").append(insertUpdateRemark);
        sb.append(", deleted=").append(deleted);
        sb.append(", serialVersionUID=").append(serialVersionUID);
        sb.append("]");
        return sb.toString();
    }
}